#ifndef __INC_H__
#define __INC_H__

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <glib.h>

#include "mainwindow.h"
#include "progressdialog.h"
#include "prefs_account.h"
#include "pop.h"
#include "socket.h"

typedef struct _Pop3State	Pop3State;

typedef enum
{
	INC_SUCCESS,
	INC_ERROR,
	INC_NOSPACE,
	INC_CANCEL
} IncState;

struct _Pop3State
{
	ProgressDialog *progress;
	gboolean cancelled;
	PrefsAccount *ac_prefs;
	GHashTable *folder_table;

	MainWindow *mainwin;

	gchar *prev_folder;

	SockInfo *sockinfo;

	gchar *greeting;
	gchar *user;
	gchar *pass;
	gint count;
	gint new;
	gint bytes;
	gint cur_msg;

	/* UIDL */
	GHashTable *id_table;
	GSList *id_list;
	GSList *new_id_list;

	gint error_val;
	IncState *retval;
};

#define TIMEOUT_ITV	200

void inc_mail			(MainWindow	*mainwin);
void inc_all_account_mail	(MainWindow	*mainwin);
void inc_progress_update	(Pop3State	*state,
				 Pop3Phase	 phase);
gint inc_drop_message		(const gchar	*file,
				 Pop3State	*state);

#endif /* __INC_H__ */
